SystemOrganization addCategory: #ConfigurationOfMoney!

Object subclass: #ConfigurationOfMoney
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMoney'!

!ConfigurationOfMoney class methodsFor: 'development support' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMoney class methodsFor: 'private' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMoney class methodsFor: 'private' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMoney class methodsFor: 'private' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMoney class methodsFor: 'metacello tool support' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMoney class methodsFor: 'loading' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMoney class methodsFor: 'loading' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMoney class methodsFor: 'loading' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMoney class methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
project

	^self new project! !

!ConfigurationOfMoney class methodsFor: 'development support' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMoney methodsFor: 'baselines' stamp: 'PaulDeBruicker 11/1/2012 18:32'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/Money'.
			spec package: 'Money' with: [ spec requires: #('JSON') ].
			spec
				repository: 'http://www.squeaksource.com/JSON';
				package: 'JSON'.
			spec group: 'Core' with: #('Money') ]! !

!ConfigurationOfMoney methodsFor: 'baselines' stamp: 'PaulDeBruicker 2/8/2013 13:40'!
baseline11: spec
	<version: '1.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec
				description:
					'added XMLSupport as a dependency to be able to load iso codes from iso.org. Uses json to get the cross currency exchange rates. ugh'.
			spec
				repositories: [ 
					spec
						repository: 'http://www.squeaksource.com/JSON';
						repository: 'http://www.squeaksource.com/Money' ].
			spec
				project: 'XMLSupport'
					with: [ 
							spec
								className: 'ConfigurationOfXMLSupport';
								file: 'ConfigurationOfXMLSupport';
								loads: #('Core');
								repository: 'http://www.squeaksource.com/XMLSupport' ];
				package: 'Money' with: [ spec requires: #('JSON' 'XMLSupport') ];
				package: 'JSON'.
			spec group: 'Core' with: #('Money') ]! !

!ConfigurationOfMoney methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/1/2012 18:17'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMoney methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 13:42'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfMoney methodsFor: 'versions' stamp: 'PaulDeBruicker 1/29/2013 11:23'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: 'Initial config'.
			spec author: 'PaulDeBruicker'.
			spec timestamp: '11/1/2012 18:19'.
			spec
				package: 'Money' with: 'Money-PaulDeBruicker.47';
				package: 'JSON' with: 'JSON-ul.35' ]! !

!ConfigurationOfMoney methodsFor: 'versions' stamp: 'PaulDeBruicker 3/13/2013 15:41'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: 'initial development version'.
			spec author: 'PaulDeBruicker'.
			spec timestamp: '2/8/2013 13:40'.
			spec project: 'XMLSupport' with: #stable.
			spec
				package: 'Money' with: 'Money-PaulDeBruicker.51';
				package: 'JSON' with: 'JSON-ul.35' ]! !
